> For the complete documentation index, see [llms.txt](https://docs.veza.com/4yItIzMvkpAvMVFAamTf/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.veza.com/4yItIzMvkpAvMVFAamTf/developers/api/management/datasources.md).

# Data Sources

Each cloud provider will have one or more associated data sources. Each represents a discrete instance of a service that Veza connects to for the discovery and extraction of authorization metadata.

The provider under `/providers/aws/{id}`, for example, may have an associated EC2 data source, represented as:

```json
{
  "id": "6961b032-3fd7-4baa-a230-146d1b70ec27",
  "name": "AWS EC2 (527398259632)",
  "datasource_type": "EXTRACTOR",
  "agent_type": "AWS_EC2",
  "status": "SUCCESS",
  "provider_id": "cd0cf102-e86c-4599-9cbe-64d2c6b83236",
  "path": "AWS/ec2",
  "state": "ENABLED",
  "effective_state": "ENABLED",
  "datasource_config": null,
  "created_at": "2021-10-26T07:10:38Z",
  "updated_at": "2021-10-26T07:10:38Z",
  "sync_start": "2022-01-13T20:53:20Z",
  "sync_end": "2022-01-13T20:53:23Z",
  "sync_start_success": "2022-01-13T20:53:20Z",
  "sync_end_success": "2022-01-13T20:53:23Z",
  "parse_start": "2022-01-13T20:53:24Z",
  "parse_end": "2022-01-13T20:53:29Z",
  "parse_start_success": "2022-01-13T20:53:24Z",
  "parse_end_success": "2022-01-13T20:53:29Z"
}
```

You can use the API to get or update data source records, or enable and disable individual data sources.

{% hint style="warning" %}
Disabling a data source will cancel all pending extractions.
{% endhint %}

### Available Endpoints

#### Core Data Source Operations

<table data-view="cards"><thead><tr><th></th><th></th><th data-hidden data-card-target data-type="content-ref"></th></tr></thead><tbody><tr><td><strong>List Data Sources</strong></td><td>Retrieve all data sources with filtering and pagination</td><td><a href="/pages/b8rRw7g7JrTovQqlE3qt">/pages/b8rRw7g7JrTovQqlE3qt</a></td></tr><tr><td><strong>List Data Sources (Batch by ID)</strong></td><td>Fetch a known set of data sources by ID or external ID in one call</td><td><a href="/pages/eQ0SZS13TQXcwzu62gtf">/pages/eQ0SZS13TQXcwzu62gtf</a></td></tr><tr><td><strong>Get Data Source</strong></td><td>Retrieve details for a specific data source</td><td><a href="/pages/YMCLEjc3ChRwxQ9mujU8">/pages/YMCLEjc3ChRwxQ9mujU8</a></td></tr><tr><td><strong>Update Data Source</strong></td><td>Update the name for a data source</td><td><a href="/pages/XkUuu8WA4waHPlDlwWGx">/pages/XkUuu8WA4waHPlDlwWGx</a></td></tr><tr><td><strong>Disable Data Source</strong></td><td>Pause discovery and extraction for a data source</td><td><a href="/pages/6QxzktvLWkkMNKqDUASy">/pages/6QxzktvLWkkMNKqDUASy</a></td></tr><tr><td><strong>Enable Data Source</strong></td><td>Resume monitoring and queue for extraction</td><td><a href="/pages/yIynb02pTQFwraGdk718">/pages/yIynb02pTQFwraGdk718</a></td></tr></tbody></table>

#### Lifecycle Management Operations

<table data-view="cards"><thead><tr><th></th><th></th><th data-hidden data-card-target data-type="content-ref"></th></tr></thead><tbody><tr><td><strong>List Lifecycle Manager Datasources</strong></td><td>List datasources with lifecycle management capabilities</td><td><a href="/pages/Fl5OAKWiALFzsVSNnb6E">/pages/Fl5OAKWiALFzsVSNnb6E</a></td></tr><tr><td><strong>Get Lifecycle Manager Datasource</strong></td><td>Get details for a specific lifecycle manager datasource</td><td><a href="/pages/tRbrklCAu0z5TR9bfxAt">/pages/tRbrklCAu0z5TR9bfxAt</a></td></tr><tr><td><strong>List by Action Type</strong></td><td>Find datasources that support specific action types</td><td><a href="/pages/vsDuMfAfE9L77rxzE7iI">/pages/vsDuMfAfE9L77rxzE7iI</a></td></tr></tbody></table>

#### Status and Monitoring

<table data-view="cards"><thead><tr><th></th><th></th><th data-hidden data-card-target data-type="content-ref"></th></tr></thead><tbody><tr><td><strong>Get Parse Status</strong></td><td>Retrieve parsing status and details</td><td><a href="/pages/ZOJBI07LvwiT9d4T4QIL">/pages/ZOJBI07LvwiT9d4T4QIL</a></td></tr><tr><td><strong>Get Sync Status</strong></td><td>Retrieve synchronization status and details</td><td><a href="/pages/dvZ7b86aJknMAlCAITRI">/pages/dvZ7b86aJknMAlCAITRI</a></td></tr></tbody></table>

### Related APIs

For working with custom applications and Open Authorization API (OAA), see:

* [Open Authorization API](/4yItIzMvkpAvMVFAamTf/developers/api/oaa/rest-api.md)
* [OAA Operations](/4yItIzMvkpAvMVFAamTf/developers/api/oaa/rest-api/operations.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.veza.com/4yItIzMvkpAvMVFAamTf/developers/api/management/datasources.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
